--scout's cu-
--by minenice

--basically duplicate of jarate with new effects

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

local milkRadius = 420*FRACUNIT

local blib_milkBoostName = "xItem_MadMilk"
local milkBoostShortFrame = 6
local milkBoostLongFrame = TICRATE
local milkBoostShortSpeed = 2*FRACUNIT
local milkBoostShortAccel = 4*FRACUNIT
local milkBoostLongSpeed = 3*FRACUNIT/2
local milkBoostLongAccel = 3*FRACUNIT/2

local milkBuffFrame = TICRATE
local milkBuffFrame_Mercy = 2*TICRATE/3

local fes_init_milk = false

freeslot(
	"MT_MILKJUG",
	"MT_MILKDRIP",
	"S_MILKJUG",
	"S_MILKJUG_EXPLODE",
	"S_MILKDRIP",
	
	"SPR_MLKJ",
	"SPR_MLCU",
	
	"sfx_milkok",
	"sfx_milsh1",
	"sfx_milsh2",
	"sfx_milksg"
)

mobjinfo[MT_MILKJUG] = {
	doomednum = -1,
    spawnstate = S_MILKJUG,
	deathstate = S_MILKJUG_EXPLODE,
	deathsound = sfx_jarppl,
    spawnhealth = 9000,
    radius = 8*FRACUNIT,
    height = 8*FRACUNIT,
	speed = 42*FRACUNIT,
    flags = MF_MISSILE|MF_DONTENCOREMAP
}

mobjinfo[MT_MILKDRIP] = {
	doomednum = -1,
    spawnstate = S_MILKDRIP,
    spawnhealth = 9000,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP
}

states[S_MILKJUG] = {
	sprite = SPR_MLKJ,
	frame = FF_ANIMATE|A,
	tics = -1,
	nextstate = S_MILKJUG,
	var1 = 6,
	var2 = 1,
}

states[S_MILKJUG_EXPLODE] = {
	sprite = SPR_MLCU,
	frame = FF_ANIMATE|TR_TRANS40|A,
	tics = 3*2,
	nextstate = S_INVISIBLE,
	var1 = 3,
	var2 = 2,
}

states[S_MILKDRIP] = {
	sprite = SPR_MLCU,
	frame = TR_TRANS20|E,
	tics = TICRATE/2,
	nextstate = S_NULL
}

local function checkPlayerMoValid(p)
	return (p and p.mo and p.mo.valid)
end

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP) then
		mo.z = $ + (master.height - FixedMul(master.scale, mo.height))
	end
end

local function milkOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	if p.madMilkData and p.madMilkData.milkCooldown > 0 then
		return 0
	end
	local skin = p.mo and p.mo.skin or "sonic"
	if (skin == "tf2-scout" or skin == "scout") and newodds > 0 then
		--secret easter egg
		return newodds + 1
	end
	return newodds
end

local function getMilk(p, i)
	local skin = p.mo.skin or "sonic"
	if leveltime%2 and (skin == "tf2-scout" or skin == "scout") then
		S_StartSound(p.mo, sfx_milksg)
	end
	if p.madMilkData then
		p.madMilkData.milkCooldown = 20*TICRATE
	end
end

local function throwMilk(p, cmd)
	local mo = p.mo
	local kartstuff = p.kartstuff
	
	kartstuff[k_itemamount] = $-1
	
	local jar = P_SpawnPlayerMissile(mo, MT_MILKJUG)
	if jar then
		jar.splatted = false
		jar.target = p.mo
		
		if p.kartTeam ~= nil then
			jar.kartTeam = p.kartTeam
		end
		
		if kartstuff[k_throwdir] then
			if kartstuff[k_throwdir] == -1 then
				jar.momx = 0
				jar.momy = 0
				jar.momz = 12*mapobjectscale*P_MobjFlip(mo) + mo.momz
			else
				jar.momx = $ + mo.momx
				jar.momy = $ + mo.momy
				jar.momz = 14*mapobjectscale*P_MobjFlip(mo) + mo.momz
			end
		else
			jar.momx = $ + mo.momx/4
			jar.momy = $ + mo.momy/4
			jar.momz = 8*mapobjectscale*P_MobjFlip(mo) + mo.momz
		end
	end
	
	S_StartSound(p.mo, sfx_jarppu)
	K_PlayAttackTaunt(p.mo)
	
	-- + orbinaut
	if kartstuff[k_itemamount] == 0 then
		kartstuff[k_itemamount] = 1
		kartstuff[k_itemtype] = KITEM_ORBINAUT
		kartstuff[k_itemblink] = 6
		kartstuff[k_itemblinkmode] = 0
	end
end

local function resetMilkData(p)
	p.madMilkData = {
		milkCooldown = 0, --20 seconds after get cum
		milkEffectTime = 0, --10 seconds of cummed
		milkBoostTime = 0,
		
		overrideFlashTime = 0,
	}
end

--thanks call
local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

local function handleMilkJugExplode(mo)
	local milkedVictim = false
	for p in players.iterate do
		if not checkPlayerMoValid(p) then continue end
		local pmo = p.mo
		if pmo == mo.target then
			continue
		end
		if (p.kartTeam ~= nil and mo.kartTeam ~= nil) and p.kartTeam == mo.kartTeam then continue end	--make certain targets unavailable
		local dist = R_PointToDist2(0, mo.z, R_PointToDist2(mo.x, mo.y, pmo.x, pmo.y), pmo.z)	--three dee
		if dist <= FixedMul(milkRadius, mapobjectscale) then
			milkedVictim = true
			if p.madMilkData then
				if fesScoring and fes_init_milk and mo.target and mo.target.player then
					FES_scoring_rewardPlayerAction(mo.target.player, "xitMadMilk")
				end
				p.madMilkData.milkEffectTime = TICRATE*10
				P_PlayRinglossSound(p.mo) --this is genuinely fucked
				
				if (hitfeed) then
					local source = generateHFForPlayer(mo.target.player)
					local victim = generateHFForPlayer(p)
					HF_SendHitMessage(source, victim, "H_XIPISS")
				end
			end
		end
		dist = nil
	end
	local skin = mo.target.skin or "sonic"
	if milkedVictim and (skin == "tf2-scout" or skin == "scout") then
		S_StartSound(mo.target, sfx_milsh1 + leveltime%2)
	end
	for i = 1, 22 do
		local r = FixedMul(milkRadius, mapobjectscale)/3
		local rh = FixedMul(milkRadius, mapobjectscale)*2/4
		local c = P_SpawnMobj(mo.x - r + FixedMul(rh, P_RandomFixed()), mo.y - r + FixedMul(rh, P_RandomFixed()), mo.z - r + FixedMul(rh, P_RandomFixed()), MT_THOK)
		c.scale = mapobjectscale/3
		c.destscale = mapobjectscale
		c.state = S_PEEPEECLOUD
		c.color = SKINCOLOR_WHITE
		c.colorized = true
		c.momx = (-r + FixedMul(rh, P_RandomFixed()))/8
		c.momy = (-r + FixedMul(rh, P_RandomFixed()))/8
		c.momz = 0
		r = nil
		rh = nil
	end
end

local function playerMilkThinker(p)
	local mo = p.mo
	if not p.madMilkData or leveltime == 0 then
		resetMilkData(p)
		return
	end
	local kartstuff = p.kartstuff
	local madMilkData = p.madMilkData
	if madMilkData.milkCooldown then madMilkData.milkCooldown = $-1 end
	
	if madMilkData.milkEffectTime then 
		local overlay = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		overlay.state = S_PEEPEEOVERLAY
		overlay.momx = mo.momx
		overlay.momy = mo.momy
		overlay.momz = mo.momz
		overlay.skin = mo.skin
		overlay.scale = mo.scale + 34
		overlay.angle = p.frameangle
		overlay.color = SKINCOLOR_WHITE
		overlay.colorized = true
		overlay.frame = mo.frame|TR_TRANS40
		K_FlipFromObject(overlay, mo)
		
		madMilkData.milkEffectTime = $-1 
		
		for i = 1, 2 do
			local drip = P_SpawnMobj(mo.x - mo.radius + FixedMul(mo.radius*2, P_RandomFixed()), mo.y - mo.radius + FixedMul(mo.radius*2, P_RandomFixed()), mo.z + mo.height/3 + FixedMul(mo.height/2, P_RandomFixed()), MT_MILKDRIP)
			drip.destscale = 0
			drip.color = SKINCOLOR_WHITE
		end
		
		// no i-frames while milked
		if madMilkData.overrideFlashTime == 0 then
			p.powers[pw_flashing] = 0
		end
	end
	
	if madMilkData.overrideFlashTime then
		madMilkData.overrideFlashTime = $-1
	end
	
	if madMilkData.milkBoostTime then
		--TODO: VFX (something that emulates the overheal effect + a spark effect on boost first frame?)
		if BLib then
			if madMilkData.milkBoostTime >= milkBoostLongFrame - milkBoostShortFrame then
				BLib.SetBoost(p, blib_milkBoostName, milkBoostShortSpeed, milkBoostShortAccel)
			else
				BLib.SetBoost(p, blib_milkBoostName, milkBoostLongSpeed, milkBoostLongAccel)
			end
		end
		madMilkData.milkBoostTime = $-1
	else
		if BLib then
			BLib.SetBoost(p, blib_milkBoostName, 0, 0)
		end
	end
end

local function doMilkBoost(source)
	local kartstuff = source.kartstuff
	local mo = source.mo
	if kartstuff[k_squishedtimer] or kartstuff[k_spinouttimer] then
		-- if we're in damage state just cancel out of it
		kartstuff[k_squishedtimer] = 0
		kartstuff[k_spinouttimer] = 0
		
		-- bit of mercy if already milked
		if source.madMilkData.milkEffectTime then
			source.powers[pw_flashing] = max($, milkBuffFrame_Mercy)
			source.madMilkData.overrideFlashTime = max($, milkBuffFrame_Mercy)
		end
	else
		-- otherwise if we're fine give some iframes to simulate a healing effect
		source.powers[pw_flashing] = max($, milkBuffFrame)
		source.madMilkData.overrideFlashTime = max($, milkBuffFrame)
	end
	kartstuff[k_sneakertimer] = max($, milkBoostShortFrame)
	kartstuff[k_startboost] = max($, milkBoostShortFrame)
	kartstuff[k_driftboost] = max($, milkBoostLongFrame)
	source.madMilkData.milkBoostTime = milkBoostLongFrame
	

	S_StartSound(null, sfx_milkok, source)
	for i = 1, 20 do
		local drip = P_SpawnMobj(mo.x - P_ReturnThrustX(null, mo.angle, mo.radius), mo.y - P_ReturnThrustY(null, mo.angle, mo.radius), mo.z + (mo.height/3*P_MobjFlip(mo)), MT_MILKDRIP)
		local ang = (360/20*ANG1) * i

		P_InstaThrust(drip, mo.angle + 90*ANG1, P_ReturnThrustX(null, ang, 6*FRACUNIT))
		drip.momz = P_ReturnThrustY(null, ang, 6*FRACUNIT) + 4*FRACUNIT + mo.momz
		drip.momx = $ + mo.momx
		drip.momy = $ + mo.momy

		drip.scale = mapobjectscale*2

		drip.destscale = 0
		drip.color = SKINCOLOR_WHITE
	end
end

addHook("MobjDeath", function(mo)
	if (mo.player and mo.valid) then
		local p = mo.player
		resetMilkData(p)
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	local p = mo.player
	playerMilkThinker(p)
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if mo and mo.state == S_MILKJUG_EXPLODE and not mo.splatted then
		mo.scale = mapobjectscale * 4
		mo.destscale = mapobjectscale * 6
		mo.splatted = true
		handleMilkJugExplode(mo)
	end
	if mo and mo.state == S_INVISIBLE then
		if not mo.fuse then
			mo.fuse = TICRATE
		elseif mo.fuse == 1 then
			mo.state = S_NULL
		end
	end
end, MT_MILKJUG)

addHook("ShouldDamage", function(target, inflictor, source)
	if inflictor and inflictor.valid and inflictor.type == MT_MILKJUG then
		return false
	end
end, MT_PLAYER)

--mad milk gives attacker boost and iframes
addHook("PlayerSpin", function(p, inflictor, source)
	if p.madMilkData and p.madMilkData.milkEffectTime then
		local mo = p.mo
		-- attacker is source
		if source.player then
			doMilkBoost(source.player)
		end
	end
end)

addHook("PlayerExplode", function(p, inflictor, source)
	if p.madMilkData and p.madMilkData.milkEffectTime then
		local mo = p.mo
		-- attacker is source
		if source.player then
			doMilkBoost(source.player)
		end
	end
end)

addHook("PlayerSquish", function(p, inflictor, source)
	if p.madMilkData and p.madMilkData.milkEffectTime then
		local mo = p.mo
		-- attacker is source
		if source.player then
			doMilkBoost(source.player)
		end
	end
end)

addHook("ThinkFrame", function()
	if fesScoring and not fes_init_milk then
		FES_scoring_addAction("xitMadMilk", "Mad Milk Splash", 10)
	end
end)

if xItemLib then
	xItemLib.func.addItem{"XITEM_SAMPLER_MILK", "Mad Milk", "K_ITMILK", "K_ISMILK", 0, {0, 0, 8, 8, 6, 4, 4, 1, 0, 0}, {2, 0}, getMilk, throwMilk, false, milkOdds, false, {0, {SPR_XITS, 8}}, true, nil, nil}
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_SAMPLER_MILK", {
		tipDescription1 = "Jug creates splash of Mad Milk",
		tipDescription2 = "Hitting sodden victims gives boost and flashtics",
		tipUsage1 = "Press \130Fire\128 to fire item",
		tipUsage2 = "Follow up with added Orbinaut",
	})
end