--shrink but funny
--by minenice

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

local metreSize = 64*FRACUNIT
local areaEffectCloudRadius = 3*metreSize
local areaEffectCloudFrame = TICRATE * 30
local areaEffectCloudNoEffectFrame = TICRATE/4	-- 1/4 the time compared to mc itself
local areaEffectFirstHitLife = TICRATE*5
local areaEffectFirstHitRadius = metreSize/2

local effectDuration = TICRATE*6

local fes_init_lingersmall = false

local function onPotionImpact(mo)
	local area = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PICKEL_POTIONAREA)
	if area then
		S_StartSound(area, sfx_psmdt0 + leveltime % 3)
		area.target = mo.target
		area.destscale = 0
		area.scalespeed = FRACUNIT/areaEffectCloudFrame
		area.intensity = 3
		area.firstApplied = false
	end

end

function A_PickelPotionImpact(mo)
	onPotionImpact(mo)
end

freeslot(
	"MT_PICKEL_POTION",
	"MT_PICKEL_POTIONAREA",
	
	"S_PICKEL_POTION",
	"S_PICKEL_POTIONIMPACT",
	"S_PICKEL_POTIONAREA",
	"S_PICKEL_EFFECT",
	"S_PICKEL_EFFECT2",
	
	"SPR_PSML",
	
	"sfx_psmuse",
	"sfx_psmdt0",
	"sfx_psmdt1",
	"sfx_psmdt2",
	"sfx_psmht1",
	"sfx_psmht2"
)

mobjinfo[MT_PICKEL_POTION] = {
	doomednum = -1,
    spawnstate = S_PICKEL_POTION,
    spawnhealth = 9000,
	deathstate = S_PICKEL_POTIONIMPACT,
    radius = 8*FRACUNIT,
    height = 8*FRACUNIT,
	speed = 48*FRACUNIT,
    flags = MF_MISSILE|MF_DONTENCOREMAP
}

mobjinfo[MT_PICKEL_POTIONAREA] = {
	doomednum = -1,
    spawnstate = S_PICKEL_POTIONAREA,
    spawnhealth = 9000,
    radius = areaEffectCloudRadius,
    height = metreSize,
    flags = MF_SPECIAL
}

states[S_PICKEL_POTION] = {
	sprite = SPR_PSML,
	frame = A,
	tics = -1,
}

states[S_PICKEL_POTIONIMPACT] = {
	sprite = SPR_NULL,
	action = A_PickelPotionImpact,
	nextstate = S_NULL,
	frame = A,
	tics = 0,
}

states[S_PICKEL_POTIONAREA] = {
	sprite = SPR_NULL,
	frame = A,
	tics = areaEffectCloudFrame,
}

states[S_PICKEL_EFFECT] = {
	sprite = SPR_PSML,
	frame = FF_FULLBRIGHT|FF_ANIMATE|B,
	tics = 8*2,
	nextstate = S_NULL,
	var1 = 7,
	var2 = 2,
}

-- to improve visibility on magenta-coloured surfaces 🥹
states[S_PICKEL_EFFECT2] = {
	sprite = SPR_PSML,
	frame = FF_FULLBRIGHT|FF_ANIMATE|J,
	tics = 8*2,
	nextstate = S_NULL,
	var1 = 7,
	var2 = 2,
}

sfxinfo[sfx_psmdt0] = {
	singular = false,
	flags = SF_X2AWAYSOUND
}

sfxinfo[sfx_psmdt1] = {
	singular = false,
	flags = SF_X2AWAYSOUND
}

sfxinfo[sfx_psmdt2] = {
	singular = false,
	flags = SF_X2AWAYSOUND
}

local function checkPlayerMoValid(p)
	return (p and p.mo and p.mo.valid)
end

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP) then
		mo.z = $ + (master.height - FixedMul(master.scale, mo.height))
	end
end

local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

local function ClassPlayer()
	return {
		effectEndTime = -1
	}
end

local function getPotion(p, i)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE/4)
end

local maxEligibleDistance = 80*metreSize
local function potionOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	-- if in first place return as-is
	if p.kartstuff[k_position] == 1 then
		return newodds
	else
		for p2 in players.iterate do
			if p2 and p2.mo and (not p2.spectator) and (p2.kartstuff[k_position] == 1) and p2.kartstuff[k_position] < p.kartstuff[k_position] then
				local pdis = R_PointToDist2(p2.mo.x, p2.mo.y, p.mo.x, p.mo.y)
				if pdis > FixedMul(maxEligibleDistance, mapobjectscale) then
					return 0
				end
			end
		end
	end
	return newodds
end

local function usePotion(p, cmd)
	local mo = p.mo
	local kartstuff = p.kartstuff
	
	kartstuff[k_itemamount] = $-1
	S_StartSound(p.mo, sfx_psmuse)
	K_PlayAttackTaunt(p.mo)
	
	local pot = P_SpawnPlayerMissile(mo, MT_PICKEL_POTION)
	if pot then
		pot.splatted = false
		pot.target = mo
		
		-- potion effect can affect teammates
-- 		if p.kartTeam ~= nil then
-- 			pot.kartTeam = p.kartTeam
-- 		end
		
		if kartstuff[k_throwdir] then
			if kartstuff[k_throwdir] == -1 then
				pot.momx = $ + mo.momx/3
				pot.momy = $ + mo.momy/3
				pot.momz = 8*mapobjectscale*P_MobjFlip(mo) + mo.momz
			else
				pot.momx = $ + mo.momx
				pot.momy = $ + mo.momy
				pot.momz = 16*mapobjectscale*P_MobjFlip(mo) + mo.momz
			end
		else
			pot.momx = $ + 3*mo.momx/4
			pot.momy = $ + 3*mo.momy/4
			pot.momz = 12*mapobjectscale*P_MobjFlip(mo) + mo.momz
		end
		
		K_FlipFromObject(pot, mo)
	end
	
	
end

local function playerThinker(p)
	local mo = p.mo
	if not p.smallPotData or leveltime == 0 then
		p.smallPotData = ClassPlayer()
		return
	end
	
	if p.smallPotData and leveltime < p.smallPotData.effectEndTime then
		local emm = P_SpawnMobj(mo.x - mo.radius + FixedMul(mo.radius*2, P_RandomFixed()), 
		mo.y - mo.radius + FixedMul(mo.radius*2, P_RandomFixed()), 
		mo.z + mo.height/2 + FixedMul(mo.height/2, P_RandomFixed()), 
		MT_THOK)

		emm.state = S_PICKEL_EFFECT + leveltime % 2

		emm.momz = P_MobjFlip(mo)*mapobjectscale
	end
end

local function potionAreaSpecial(s, t)
	if s.tics >= areaEffectCloudFrame - areaEffectCloudNoEffectFrame then
		return true
	end
	if t and t.health and t.player then
		local p = t.player
		if (p.kartstuff[k_invincibilitytimer] > 0 
			or p.powers[pw_flashing] > 0 or p.kartstuff[k_spinouttimer] > 0
			or (p.smallPotData and leveltime < p.smallPotData.effectEndTime)) then
			return true
		else
			--simulate minecraft's global potion timer behaviour
			p.smallPotData.effectEndTime = (leveltime/TICRATE)*TICRATE + effectDuration
			
			P_PlayRinglossSound(p.mo)
			S_StartSound(mo, sfx_psmht1 + leveltime%2, p)
			
			-- if in grow, shrink to normal state
			-- if normal, shrink to shrunken state
			-- if shrunk, set timer to whatever is larger
			if p.kartstuff[k_growshrinktimer] > 0 then
				-- let the normal shrinking behaviour happen next tick
				p.kartstuff[k_growshrinktimer] = 1
			else
				p.kartstuff[k_growshrinktimer] = min($, -(p.smallPotData.effectEndTime - leveltime))
				p.mo.scalespeed = mapobjectscale/TICRATE
				p.mo.destscale = 6*mapobjectscale/8
			end
			
			if (hitfeed) then
				local source = nil
				if p != s.target.player then
					source = generateHFForPlayer(s.target.player)
				end
				local victim = generateHFForPlayer(p)
				HF_SendHitMessage(source, victim, "H_XIPSML")
			end
			
			if not s.firstApplied then
				s.firstApplied = true
				if s.radius - FixedMul(areaEffectFirstHitRadius, mapobjectscale) > 0 then
					s.scale = max(FixedDiv((s.radius - FixedMul(areaEffectFirstHitRadius, mapobjectscale)), s.radius), 0)
					if s.scale > 0 then					
						s.tics = max($ - areaEffectFirstHitLife, 1)
						s.destscale = 0
						s.scalespeed = s.scale/s.tics
					else
						s.tics = 0
						s.state = S_NULL
					end
				else
					s.tics = 0
					s.state = S_NULL
				end
			end
		end
	end
	return true
end

local numParticles = 4
local ptcl, rang
local function potionAreaThinker(mo)
	mo.intensity = FixedMul(numParticles*FRACUNIT, FixedDiv(mo.radius, FixedMul(areaEffectCloudRadius, mapobjectscale)))/FRACUNIT
	for i = 1, max(mo.intensity, 1) do
		if mo.intensity == 0 and leveltime%4 then
			break
		end
		rang = P_RandomKey(360) * ANG1
		ptcl = P_SpawnMobj(mo.x + P_ReturnThrustX(nil, rang, 2*FixedMul(P_RandomFixed() - FRACUNIT/2, mo.radius + FixedMul(metreSize/2, mapobjectscale))), 
			mo.y + P_ReturnThrustY(nil, rang, 2*FixedMul(P_RandomFixed() - FRACUNIT/2, mo.radius + FixedMul(metreSize/2, mapobjectscale))), 
			mo.z, 
			MT_THOK)

		ptcl.state = S_PICKEL_EFFECT + ((leveltime + rang + i) % 2)

		ptcl.momz = 2*P_MobjFlip(mo)*mapobjectscale
		ptcl.scale = P_RandomRange(3,5)*mapobjectscale/2
	end
end

addHook("MobjThinker", function(mo)
	local p = mo.player
	playerThinker(p)
end, MT_PLAYER)

addHook("ShouldDamage", function(target, inflictor, source)
	if inflictor and inflictor.valid and inflictor.type == MT_PICKEL_POTION then
		return false
	end
end, MT_PLAYER)

addHook("TouchSpecial", potionAreaSpecial, MT_PICKEL_POTIONAREA)
addHook("MobjThinker", potionAreaThinker, MT_PICKEL_POTIONAREA)

addHook("ThinkFrame", function()
	if fesScoring and not fes_init_lingersmall then
		FES_scoring_addAction("xitPotionSmall", "Lingering Potion of Small Splash", 5)
	end
end)

if xItemLib then
	xItemLib.func.addItem{"XITEM_SAMPLER_POTIONSMALL", 
		"Lingering Potion of Small", 
		"K_ITPSML", 
		"K_ISPSML", 
		XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_UNIQUE, 
		{0, 1, 4, 2, 0, 0, 0, 0, 0, 0}, 
		{3, 0},
		getPotion, 
		usePotion, 
		false, 
		false, 
		false, 
		{0, {SPR_XITS, 9}}, 
		true, 
		nil, 
		nil
    }
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_SAMPLER_POTIONSMALL", {
		tipDescription1 = "Get Lingering Potion of Small",
		tipDescription2 = "Creates a cloud that shrinks racers for a while",
		tipUsage1 = "Press \130Fire\128 to throw",
		tipUsage2 = "Can also affect user",
	})
end